This page provides an introduction and quick start guide for the Block Storage API:
- Overview—See a high-level description of the API.
- Developer guide—Review a quick start guide that helps you get started with the API.
The HPE GreenLake for Block Storage REST APIs let you programmatically create, manage, and monitor block storage resources to support integration and automation. Block Storage is a service in Data Services Cloud Console that handles volume lifecycle management, native replication, and snapshot-based data protection. Using these APIs, you can provision, protect, and operate volumes and volume sets to enable automated workflows for provisioning, replication, snapshots, and monitoring of block storage resources.
- Create, list, update, and delete volumes
- Create, manage, and delete snapshots and snapshot schedules
- Create, manage, and delete volume sets
- Attach and detach volumes to/from hosts and host groups
- Manage initiators and initiator groups
- Configure and manage QoS policies
- Enable/disable volume encryption and integrate with key management
- Perform space reclamation and thin provisioning management
- Monitor capacity, health, and performance for volumes and pools
- Manage replication relationships and protection policies
HPE GreenLake for Block Storage provides RESTful APIs to programmatically create, manage, and monitor block storage resources, enabling seamless integration and automation.
Endpoints are the host URLs that you submit your API requests to. Block Storage has unique endpoints in specific regions. Use the following list to identify your application endpoint.
- US West: https://us-west.api.greenlake.hpe.com
- EU West: https://eu-west.api.greenlake.hpe.com
- EU Central: https://eu-central.api.greenlake.hpe.com
- AP NorthEast: https://ap-northeast.api.greenlake.hpe.com
The Block Storage API uses an access token for authentication. Instructions for obtaining an access token can be found on the Authentication page.
The HTTP Authorization request header is used to provide the access token in all API requests as a Bearer token.
Authorization:Bearer <access token>
All API requests are authorized using permissions. The user owning the access token must have the required permissions assigned for the resources being accessed in order to be authorized. The required permissions are documented in the following guide pages.
To use the HPE GreenLake Block Storage API, you need appropriate permissions based on your role:
block-storage.host-initiator-group.readfor allGETandLISTrequests on host initiator group resourcesblock-storage.host-initiator-group.createfor allPOSTrequests on host initiator group resourcesblock-storage.host-initiator-group.updatefor allPUTrequests on host initiator group resourcesblock-storage.host-initiator-group.deletefor allDELETErequests on host initiator group resourcesblock-storage.host-initiator.readfor allGETandLISTrequests on host initiator resourcesblock-storage.host-initiator.createfor allPOSTrequests on host initiator resourcesblock-storage.host-initiator.updatefor allPUTrequests on host initiator resourcesblock-storage.host-initiator.deletefor allDELETErequests on host initiator resourcesblock-storage.performance-template.readfor allGETandLISTrequests on performance template resourcesblock-storage.performance-template.createfor allPOSTrequests on performance template resourcesblock-storage.performance-template.updatefor allPUTrequests on performance template resourcesblock-storage.performance-template.deletefor allDELETErequests on performance template resourcesblock-storage.protection-template.readfor allGETandLISTrequests on protection template resourcesblock-storage.protection-template.createfor allPOSTrequests on protection template resourcesblock-storage.protection-template.updatefor allPUTrequests on protection template resourcesblock-storage.protection-template.deletefor allDELETErequests on protection template resourcesblock-storage.bucket.readfor allGETandLISTrequests on bucket resources
For more information about roles and permissions, see the HPE GreenLake Cloud User Guide.
For asynchronous operations that return HTTP status 201 or 202, use the Location header in the API response to track progress.
Replace the base URL in examples with the endpoint for your region.
Create a volume on an HPE Alletra Storage MP B10000 device.
POST https://us-west.api.greenlake.hpe.com/block-storage/v1alpha1/devtype4-storage-systems/{systemId}/volumesPayload:
{
"comments": "test",
"count": 2,
"dataReduction": true,
"name": "<resource_name>",
"ransomware": true,
"sizeMib": 16384,
"snapshotAllocWarning": 5,
"userAllocWarning": 5,
"userCpg": "SSD_r6"
}The endpoint https://us-west.api.greenlake.hpe.com is the endpoint for the US West application. If you are using HPE GreenLake for Block Storage in a different region, replace it with the endpoint for the corresponding region.
Retrieve the list of volumes for the specified HPE Alletra Storage MP B10000 device. Replace {systemId} with your system identifier.
GET https://us-west.api.greenlake.hpe.com/block-storage/v1alpha1/devtype4-storage-systems/{systemId}/volumesUse query parameters to filter results, paginate large datasets, and return only the fields you need. Parameter names may vary by endpoint, so refer to the API reference for the specific resource.
GET https://us-west.api.greenlake.hpe.com/block-storage/v1alpha1/devtype4-storage-systems/{systemId}/volumes?name=prod-vol&limit=50&offset=0&select=id,name,sizeMibQuery parameters:
name=prod-vol—Filters results to a specific name (example filter).limit=50—Limits the number of returned records (pagination control).offset=0—Skips a number of records before returning results (pagination control).select=id,name,sizeMib—Limits the response fields to reduce payload size.
Update the properties of a volume on an HPE Alletra Storage MP B10000 device. Replace {systemId} and {volumeId} with actual IDs.
PUT https://us-west.api.greenlake.hpe.com/block-storage/v1alpha1/devtype4-storage-systems/{systemId}/volume/{volumeId}Payload:
{
"dataReduction": true,
"name": "volume_Name",
"ransomware": true,
"sizeMib": 1,
"snapshotAllocWarning": 1,
"userAllocWarning": 1,
"userCpgName": "cpg_1"
}Delete the specified volume on the given HPE Alletra Storage MP B10000 device. Replace {systemId} and {volumeId} with actual IDs.
DELETE https://us-west.api.greenlake.hpe.com/block-storage/v1alpha1/devtype4-storage-systems/{systemId}/volume/{volumeId}